searchNodes=[{"doc":"Send test even to check if Sentry configuration is correct.","ref":"Mix.Tasks.Sentry.SendTestEvent.html","title":"Mix.Tasks.Sentry.SendTestEvent","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Sentry.SendTestEvent.html#run/1","title":"Mix.Tasks.Sentry.SendTestEvent.run/1","type":"function"},{"doc":"Provides the basic functionality to submit a Sentry.Event to the Sentry Service. Configuration Add the following to your production config config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , included_environments : [ :prod ] , environment_name : :prod , tags : %{ env : &quot;production&quot; } The environment_name and included_environments work together to determine if and when Sentry should record exceptions. The environment_name is the name of the current environment. In the example above, we have explicitly set the environment to :prod which works well if you are inside an environment specific configuration config/prod.exs . An alternative is to use Mix.env in your general configuration file: config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , included_environments : [ :prod ] , environment_name : Mix . env This will set the environment name to whatever the current Mix environment atom is, but it will only send events if the current environment is :prod , since that is the only entry in the included_environments key. You can even rely on more custom determinations of the environment name. It's not uncommmon for most applications to have a &quot;staging&quot; environment. In order to handle this without adding an additional Mix environment, you can set an environment variable that determines the release level. config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , included_environments : ~w(production staging) , environment_name : System . get_env ( &quot;RELEASE_LEVEL&quot; ) || &quot;development&quot; In this example, we are getting the environment name from the RELEASE_LEVEL environment variable. If that variable does not exist, we default to &quot;development&quot; . Now, on our servers, we can set the environment variable appropriately. On our local development machines, exceptions will never be sent, because the default value is not in the list of included_environments . Filtering Exceptions If you would like to prevent certain exceptions, the :filter configuration option allows you to implement the Sentry.EventFilter behaviour. The first argument is the exception to be sent, and the second is the source of the event. Sentry.Plug will have a source of :plug , Sentry.LoggerBackend will have a source of :logger , and Sentry.Phoenix.Endpoint will have a source of :endpoint . If an exception does not come from either of those sources, the source will be nil unless the :event_source option is passed to Sentry.capture_exception/2 A configuration like below will prevent sending Phoenix.Router.NoRouteError from Sentry.Plug , but allows other exceptions to be sent. # sentry_event_filter.ex defmodule MyApp.SentryEventFilter do @behaviour Sentry.EventFilter def exclude_exception? ( % Elixir.Phoenix.Router.NoRouteError { } , :plug ) , do : true def exclude_exception? ( _exception , _source ) , do : false end # config.exs config :sentry , filter : MyApp.SentryEventFilter , included_environments : ~w(production staging) , environment_name : System . get_env ( &quot;RELEASE_LEVEL&quot; ) || &quot;development&quot; Capturing Exceptions Simply calling capture_exception/2 will send the event. By default, the event is sent asynchronously and the result can be awaited upon. The :result option can be used to change this behavior. See Sentry.Client.send_event/2 for more information. { :ok , task } = Sentry . capture_exception ( my_exception ) { :ok , event_id } = Task . await ( task ) { :ok , another_event_id } = Sentry . capture_exception ( other_exception , [ event_source : :my_source , result : :sync ] ) Options :event_source - The source passed as the first argument to Sentry.EventFilter.exclude_exception?/2 Configuring The Logger Backend See Sentry.LoggerBackend","ref":"Sentry.html","title":"Sentry","type":"module"},{"doc":"Parses and submits an exception to Sentry if current environment is in included_environments. opts argument is passed as the second argument to Sentry.send_event/2 .","ref":"Sentry.html#capture_exception/2","title":"Sentry.capture_exception/2","type":"function"},{"doc":"Reports a message to Sentry. opts argument is passed as the second argument to Sentry.send_event/2 .","ref":"Sentry.html#capture_message/2","title":"Sentry.capture_message/2","type":"function"},{"doc":"Gets the last event ID sent to the server from the process dictionary. Since it uses the process dictionary, it will only return the last event ID sent within the current process.","ref":"Sentry.html#get_last_event_id_and_source/0","title":"Sentry.get_last_event_id_and_source/0","type":"function"},{"doc":"Puts the last event ID sent to the server for the current process in the process dictionary.","ref":"Sentry.html#put_last_event_id_and_source/2","title":"Sentry.put_last_event_id_and_source/2","type":"function"},{"doc":"Sends a Sentry.Event opts argument is passed as the second argument to send_event/2 of the configured Sentry.HTTPClient . See Sentry.Client.send_event/2 for more information.","ref":"Sentry.html#send_event/2","title":"Sentry.send_event/2","type":"function"},{"doc":"Callback implementation for Application.start/2 .","ref":"Sentry.html#start/2","title":"Sentry.start/2","type":"function"},{"doc":"","ref":"Sentry.html#t:send_result/0","title":"Sentry.send_result/0","type":"type"},{"doc":"This module interfaces directly with Sentry via HTTP. The client itself can be configured via the :client configuration. It must implement the Sentry.HTTPClient behaviour and it defaults to Sentry.HackneyClient . It makes use of Task.Supervisor to allow sending tasks synchronously or asynchronously, and defaulting to asynchronous. See send_event/2 for more information. Configuration :before_send_event - allows performing operations on the event before it is sent. Accepts an anonymous function or a {module, function} tuple, and the event will be passed as the only argument. :after_send_event - callback that is called after attempting to send an event. Accepts an anonymous function or a {module, function} tuple. The result of the HTTP call as well as the event will be passed as arguments. The return value of the callback is not returned. Example configuration of putting Logger metadata in the extra context: config :sentry , before_send_event : { MyModule , :before_send } , before_send_event : { MyModule , :after_send } where: defmodule MyModule do def before_send ( event ) do metadata = Map . new ( Logger . metadata ) %{ event | extra : Map . merge ( event . extra , metadata ) } end def after_send_event ( event , result ) do case result do { :ok , id } -&gt; Logger . info ( &quot;Successfully sent event!&quot; ) _ -&gt; Logger . info ( fn -&gt; &quot;Did not successfully send event! \#{ inspect ( event ) } &quot; end ) end end end","ref":"Sentry.Client.html","title":"Sentry.Client","type":"module"},{"doc":"Generates a Sentry API authorization header.","ref":"Sentry.Client.html#authorization_header/2","title":"Sentry.Client.authorization_header/2","type":"function"},{"doc":"Get a Sentry DSN which is simply a URI. {PROTOCOL}://{PUBLIC_KEY}[:{SECRET_KEY}]@{HOST}/{PATH}{PROJECT_ID}","ref":"Sentry.Client.html#get_dsn/0","title":"Sentry.Client.get_dsn/0","type":"function"},{"doc":"","ref":"Sentry.Client.html#maybe_call_after_send_event/2","title":"Sentry.Client.maybe_call_after_send_event/2","type":"function"},{"doc":"","ref":"Sentry.Client.html#maybe_call_before_send_event/1","title":"Sentry.Client.maybe_call_before_send_event/1","type":"function"},{"doc":"","ref":"Sentry.Client.html#maybe_log_result/2","title":"Sentry.Client.maybe_log_result/2","type":"function"},{"doc":"Transform the Event struct into JSON map. Most Event attributes map directly to JSON map, with stacktrace being the exception. If the event does not have stacktrace frames, it should not be included in the JSON body.","ref":"Sentry.Client.html#render_event/1","title":"Sentry.Client.render_event/1","type":"function"},{"doc":"Makes the HTTP request to Sentry using the configured HTTP client.","ref":"Sentry.Client.html#request/3","title":"Sentry.Client.request/3","type":"function"},{"doc":"Attempts to send the event to the Sentry API up to 4 times with exponential backoff. The event is dropped if it all retries fail. Errors will be logged unless the source is the Sentry.LoggerBackend, which can deadlock by logging within a logger. Options :result - Allows specifying how the result should be returned. Options include :sync , :none , and :async . :sync will make the API call synchronously, and return {:ok, event_id} if successful. :none sends the event from an unlinked child process under Sentry.TaskSupervisor and will return {:ok, &quot;&quot;} regardless of the result. :async will start an unlinked task and return a tuple of {:ok, Task.t} on success where the Task should be awaited upon to receive the result asynchronously. If you do not call Task.await/2 , messages will be leaked to the inbox of the current process. See Task.Supervisor.async_nolink/2 for more information. :none is the default. :sample_rate - The sampling factor to apply to events. A value of 0.0 will deny sending any events, and a value of 1.0 will send 100% of events. Other options, such as :stacktrace or :extra will be passed to Sentry.Event.create_event/1 downstream. See Sentry.Event.create_event/1 for available options.","ref":"Sentry.Client.html#send_event/2","title":"Sentry.Client.send_event/2","type":"function"},{"doc":"","ref":"Sentry.Client.html#t:dsn/0","title":"Sentry.Client.dsn/0","type":"type"},{"doc":"","ref":"Sentry.Client.html#t:result/0","title":"Sentry.Client.result/0","type":"type"},{"doc":"","ref":"Sentry.Client.html#t:send_event_result/0","title":"Sentry.Client.send_event_result/0","type":"type"},{"doc":"This module provides the functionality for fetching configuration settings and their defaults. Sentry supports loading config at runtime, via {:system, &quot;SYSTEM_ENV_KEY&quot;} tuples, where Sentry will read SYSTEM_ENV_KEY to get the config value from the system environment at runtime.","ref":"Sentry.Config.html","title":"Sentry.Config","type":"module"},{"doc":"","ref":"Sentry.Config.html#after_send_event/0","title":"Sentry.Config.after_send_event/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#before_send_event/0","title":"Sentry.Config.before_send_event/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#client/0","title":"Sentry.Config.client/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#context_lines/0","title":"Sentry.Config.context_lines/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#dsn/0","title":"Sentry.Config.dsn/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#enable_source_code_context/0","title":"Sentry.Config.enable_source_code_context/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#environment_name/0","title":"Sentry.Config.environment_name/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#filter/0","title":"Sentry.Config.filter/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#hackney_opts/0","title":"Sentry.Config.hackney_opts/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#hackney_timeout/0","title":"Sentry.Config.hackney_timeout/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#in_app_module_allow_list/0","title":"Sentry.Config.in_app_module_allow_list/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#in_app_module_whitelist/0","title":"Sentry.Config.in_app_module_whitelist/0","type":"function"},{"doc":"The :included_environments config key expects a list, but if given a string, it will split the string on commas to create a list.","ref":"Sentry.Config.html#included_environments/0","title":"Sentry.Config.included_environments/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#json_library/0","title":"Sentry.Config.json_library/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#log_level/0","title":"Sentry.Config.log_level/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#max_breadcrumbs/0","title":"Sentry.Config.max_breadcrumbs/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#max_hackney_connections/0","title":"Sentry.Config.max_hackney_connections/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#permitted_log_level_values/0","title":"Sentry.Config.permitted_log_level_values/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#release/0","title":"Sentry.Config.release/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#report_deps/0","title":"Sentry.Config.report_deps/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#root_source_code_path/0","title":"Sentry.Config.root_source_code_path/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#root_source_code_paths/0","title":"Sentry.Config.root_source_code_paths/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#sample_rate/0","title":"Sentry.Config.sample_rate/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#send_max_attempts/0","title":"Sentry.Config.send_max_attempts/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#send_result/0","title":"Sentry.Config.send_result/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#server_name/0","title":"Sentry.Config.server_name/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#source_code_exclude_patterns/0","title":"Sentry.Config.source_code_exclude_patterns/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#source_code_path_pattern/0","title":"Sentry.Config.source_code_path_pattern/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#tags/0","title":"Sentry.Config.tags/0","type":"function"},{"doc":"","ref":"Sentry.Config.html#validate_config!/0","title":"Sentry.Config.validate_config!/0","type":"function"},{"doc":"Provides functionality to store user, tags, extra, and breadcrumbs context when an event is reported. The contexts will be fetched and merged into the event when it is sent. When calling Sentry.Context, Logger metadata is used to store this state. This imposes some limitations. The metadata will only exist within the current process, and the context will die with the process. For example, if you add context inside your controller and an error happens in a Task, that context will not be included. A common use-case is to set context within Plug or Phoenix applications, as each request is its own process, and so any stored context will be included should an error be reported within that request process. Example: # post_controller.ex def index ( conn , _params ) do Sentry.Context . set_user_context ( %{ id : conn . assigns . user_id } ) posts = Blog . list_posts ( ) render ( conn , &quot;index.html&quot; , posts : posts ) end It should be noted that the set_*_context/1 functions merge with the existing context rather than entirely overwriting it.","ref":"Sentry.Context.html","title":"Sentry.Context","type":"module"},{"doc":"Adds a new breadcrumb to the :breadcrumb context, specific to the current process. Breadcrumbs are used to record a series of events that led to a specific instance of an error. Breadcrumbs can contain arbitrary key data to assist in understanding what happened before an error occurred. Example iex&gt; Sentry.Context . add_breadcrumb ( message : &quot;first_event&quot; ) :ok iex&gt; Sentry.Context . add_breadcrumb ( %{ message : &quot;second_event&quot; , type : &quot;auth&quot; } ) %{ breadcrumbs : [ %{ :message =&gt; &quot;first_event&quot; , &quot;timestamp&quot; =&gt; 1562007480 } ] } iex&gt; Sentry.Context . add_breadcrumb ( %{ message : &quot;response&quot; } ) %{ breadcrumbs : [ %{ :message =&gt; &quot;second_event&quot; , :type =&gt; &quot;auth&quot; , &quot;timestamp&quot; =&gt; 1562007505 } , %{ :message =&gt; &quot;first_event&quot; , &quot;timestamp&quot; =&gt; 1562007480 } ] } iex&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ %{ :message =&gt; &quot;first_event&quot; , &quot;timestamp&quot; =&gt; 1562007480 } , %{ :message =&gt; &quot;second_event&quot; , :type =&gt; &quot;auth&quot; , &quot;timestamp&quot; =&gt; 1562007505 } , %{ :message =&gt; &quot;response&quot; , &quot;timestamp&quot; =&gt; 1562007517 } ] , extra : %{ } , request : %{ } , tags : %{ } , user : %{ } }","ref":"Sentry.Context.html#add_breadcrumb/1","title":"Sentry.Context.add_breadcrumb/1","type":"function"},{"doc":"Clears all existing context for the current process. Example iex&gt; Sentry.Context . set_tags_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . clear_all ( ) :ok iex&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ ] , extra : %{ } , request : %{ } , tags : %{ } , user : %{ } }","ref":"Sentry.Context.html#clear_all/0","title":"Sentry.Context.clear_all/0","type":"function"},{"doc":"Returns the keys used to store context in the current Process's process dictionary. Example iex&gt; Sentry.Context . context_keys ( ) [ :breadcrumbs , :tags , :user , :extra ]","ref":"Sentry.Context.html#context_keys/0","title":"Sentry.Context.context_keys/0","type":"function"},{"doc":"Retrieves all currently set context on the current process. Example iex&gt; Sentry.Context . set_user_context ( %{ id : 123 } ) iex&gt; Sentry.Context . set_tags_context ( %{ message_id : 456 } ) iex&gt; Sentry.Context . get_all ( ) %{ user : %{ id : 123 } , tags : %{ message_id : 456 } , extra : %{ } , request : %{ } , breadcrumbs : [ ] }","ref":"Sentry.Context.html#get_all/0","title":"Sentry.Context.get_all/0","type":"function"},{"doc":"Merges new fields into the :extra context, specific to the current process. This is used to set fields which should display when looking at a specific instance of an error. Example iex&gt; Sentry.Context . set_extra_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . set_extra_context ( %{ detail : &quot;bad_error&quot; } ) :ok iex&gt; Sentry.Context . set_extra_context ( %{ message : &quot;Oh no&quot; } ) :ok iex&gt; Sentry.Context . get_all ( ) %{ user : %{ } , tags : %{ } , extra : %{ detail : &quot;bad_error&quot; , id : 123 , message : &quot;Oh no&quot; } , request : %{ } , breadcrumbs : [ ] }","ref":"Sentry.Context.html#set_extra_context/1","title":"Sentry.Context.set_extra_context/1","type":"function"},{"doc":"Merges new fields into the :request context, specific to the current process. This is used to set metadata that identifies the request associated with a specific instance of an error. Example iex(1)&gt; Sentry.Context . set_request_context ( %{ id : 123 } ) :ok iex(2)&gt; Sentry.Context . set_request_context ( %{ url : &quot;www.example.com&quot; } ) :ok iex(3)&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ ] , extra : %{ } , request : %{ id : 123 , url : &quot;www.example.com&quot; } , tags : %{ } , user : %{ } }","ref":"Sentry.Context.html#set_request_context/1","title":"Sentry.Context.set_request_context/1","type":"function"},{"doc":"Merges new fields into the :tags context, specific to the current process. This is used to set fields which should display when looking at a specific instance of an error. These fields can also be used to search and filter on. Example iex&gt; Sentry.Context . set_tags_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . set_tags_context ( %{ other_id : 456 } ) :ok iex&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ ] , extra : %{ } , request : %{ } , tags : %{ id : 123 , other_id : 456 } , user : %{ } }","ref":"Sentry.Context.html#set_tags_context/1","title":"Sentry.Context.set_tags_context/1","type":"function"},{"doc":"Merges new fields into the :user context, specific to the current process. This is used to set certain fields which identify the actor who experienced a specific instance of an error. Example iex&gt; Sentry.Context . set_user_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . set_user_context ( %{ username : &quot;george&quot; } ) :ok iex&gt; Sentry.Context . get_all ( ) %{ user : %{ id : 123 , username : &quot;george&quot; } , tags : %{ } , extra : %{ } , request : %{ } , breadcrumbs : [ ] }","ref":"Sentry.Context.html#set_user_context/1","title":"Sentry.Context.set_user_context/1","type":"function"},{"doc":"Provides an Event Struct as well as transformation of Logger entries into Sentry Events. Configuration :in_app_module_allow_list - Expects a list of modules that is used to distinguish among stacktrace frames that belong to your app and ones that are part of libraries or core Elixir. This is used to better display the significant part of stacktraces. The logic is greedy, so if your app's root module is MyApp and your setting is [MyApp] , that module as well as any submodules like MyApp.Submodule would be considered part of your app. Defaults to [] . :report_deps - Flag for whether to include the loaded dependencies when reporting an error. Defaults to true.","ref":"Sentry.Event.html","title":"Sentry.Event","type":"module"},{"doc":"","ref":"Sentry.Event.html#add_metadata/1","title":"Sentry.Event.add_metadata/1","type":"function"},{"doc":"Builds a map from argument value list. For Sentry, typically the key in the map would be the name of the variable, but we don't have that available.","ref":"Sentry.Event.html#args_from_stacktrace/1","title":"Sentry.Event.args_from_stacktrace/1","type":"function"},{"doc":"Creates an Event struct out of context collected and options Options :exception - Sentry-structured exception :original_exception - Original Elixir exception struct :message - message :stacktrace - a list of Exception.stacktrace() :extra - map of extra context :user - map of user context :tags - map of tags context :request - map of request context :breadcrumbs - list of breadcrumbs :event_source - the source of the event :level - error level :fingerprint - list of the fingerprint for grouping this event","ref":"Sentry.Event.html#create_event/1","title":"Sentry.Event.create_event/1","type":"function"},{"doc":"","ref":"Sentry.Event.html#culprit_from_stacktrace/1","title":"Sentry.Event.culprit_from_stacktrace/1","type":"function"},{"doc":"","ref":"Sentry.Event.html#do_put_source_context/3","title":"Sentry.Event.do_put_source_context/3","type":"function"},{"doc":"","ref":"Sentry.Event.html#stacktrace_to_frames/1","title":"Sentry.Event.stacktrace_to_frames/1","type":"function"},{"doc":"Transforms an Exception to a Sentry event. Options :stacktrace - a list of Exception.stacktrace() :extra - map of extra context :user - map of user context :tags - map of tags context :request - map of request context :breadcrumbs - list of breadcrumbs :level - error level :fingerprint - list of the fingerprint for grouping this event","ref":"Sentry.Event.html#transform_exception/2","title":"Sentry.Event.transform_exception/2","type":"function"},{"doc":"","ref":"Sentry.Event.html#t:sentry_exception/0","title":"Sentry.Event.sentry_exception/0","type":"type"},{"doc":"","ref":"Sentry.Event.html#t:t/0","title":"Sentry.Event.t/0","type":"type"},{"doc":"This module defines a Behaviour for filtering Sentry events. There is one callback to implement. The first argument will be the exception reported, and the second is the source. Events from Sentry.PlugCapture will have :plug as a source and events from Sentry.LoggerBackend will have :logger as the source. A custom source can also be specified by passing the event_source option to Sentry.capture_exception/2 . As an example, if you wanted to exclude any ArithmeticError exceptions: defmodule MyApp.SentryEventFilter do @behaviour Sentry.EventFilter def exclude_exception? ( % ArithmeticError { } , _source ) , do : true def exclude_exception? ( _exception , _source ) , do : false end Alternatively, if you want to skip all non-500 exceptions in a Plug app: defmodule MyApp.SentryEventFilter do @behaviour Sentry.EventFilter def exclude_exception? ( exception , _ ) do Plug.Exception . status ( exception ) &lt; 500 end end Sentry uses Sentry.DefaultEventFilter by default.","ref":"Sentry.EventFilter.html","title":"Sentry.EventFilter","type":"behaviour"},{"doc":"Callback that returns whether an exception should be excluded from being reported","ref":"Sentry.EventFilter.html#c:exclude_exception?/2","title":"Sentry.EventFilter.exclude_exception?/2","type":"callback"},{"doc":"Specifies the API for using a custom HTTP Client. The default HTTP client is Sentry.HackneyClient To configure a different HTTP client, implement the Sentry.HTTPClient behaviour and change the :client configuration: config :sentry , client : MyHTTPClient","ref":"Sentry.HTTPClient.html","title":"Sentry.HTTPClient","type":"behaviour"},{"doc":"","ref":"Sentry.HTTPClient.html#c:child_spec/0","title":"Sentry.HTTPClient.child_spec/0","type":"callback"},{"doc":"","ref":"Sentry.HTTPClient.html#c:post/3","title":"Sentry.HTTPClient.post/3","type":"callback"},{"doc":"","ref":"Sentry.HTTPClient.html#t:headers/0","title":"Sentry.HTTPClient.headers/0","type":"type"},{"doc":"The built-in HTTP client.","ref":"Sentry.HackneyClient.html","title":"Sentry.HackneyClient","type":"module"},{"doc":"Report Logger events like crashed processes to Sentry. To include in your application, start this backend in your application start/2 callback: # lib/my_app/application.ex def start ( _type , _args ) do Logger . add_backend ( Sentry.LoggerBackend ) Sentry context will be included in metadata in reported events. Example: Sentry.Context . set_user_context ( %{ user_id : current_user . id } ) Configuration :excluded_domains - Any messages with a domain in the configured list will not be sent. Defaults to [:cowboy] to avoid double reporting events from Sentry.PlugCapture . :metadata - To include non-Sentry Logger metadata in reports, the :metadata key can be set to a list of keys. Metadata under those keys will be added in the :extra context under the :logger_metadata key. Defaults to [] . :level - The minimum Logger level to send events for. Defaults to :error . :capture_log_messages - When true , this module will send all Logger messages. Defaults to false , which will only send messages with metadata that has the shape of an exception and stacktrace. Example: config :logger , Sentry.LoggerBackend , # Also send warning messages level : :warning , # Send messages from Plug/Cowboy excluded_domains : [ ] , # Include metadata added with `Logger.metadata([foo_bar: &quot;value&quot;])` metadata : [ :foo_bar ] , # Send messages like `Logger.error(&quot;error&quot;)` to Sentry capture_log_messages : true","ref":"Sentry.LoggerBackend.html","title":"Sentry.LoggerBackend","type":"module"},{"doc":"Callback implementation for :gen_event.code_change/3 .","ref":"Sentry.LoggerBackend.html#code_change/3","title":"Sentry.LoggerBackend.code_change/3","type":"function"},{"doc":"Callback implementation for :gen_event.handle_call/2 .","ref":"Sentry.LoggerBackend.html#handle_call/2","title":"Sentry.LoggerBackend.handle_call/2","type":"function"},{"doc":"Callback implementation for :gen_event.handle_event/2 .","ref":"Sentry.LoggerBackend.html#handle_event/2","title":"Sentry.LoggerBackend.handle_event/2","type":"function"},{"doc":"Callback implementation for :gen_event.handle_info/2 .","ref":"Sentry.LoggerBackend.html#handle_info/2","title":"Sentry.LoggerBackend.handle_info/2","type":"function"},{"doc":"Callback implementation for :gen_event.init/1 .","ref":"Sentry.LoggerBackend.html#init/1","title":"Sentry.LoggerBackend.init/1","type":"function"},{"doc":"Callback implementation for :gen_event.terminate/2 .","ref":"Sentry.LoggerBackend.html#terminate/2","title":"Sentry.LoggerBackend.terminate/2","type":"function"},{"doc":"Provides basic functionality to handle and send errors occurring within Plug applications, including Phoenix. It is intended for usage with Sentry.PlugContext . Usage In a Phoenix application, it is important to use this module before the Phoenix endpoint itself. It should be added to your endpoint.ex: defmodule MyApp.Endpoint use Sentry.PlugCapture use Phoenix.Endpoint , otp_app : :my_app # ... end In a Plug application, it can be added below your router: defmodule MyApp.PlugRouter do use Plug.Router use Sentry.PlugCapture # ... end","ref":"Sentry.PlugCapture.html","title":"Sentry.PlugCapture","type":"module"},{"doc":"This module adds Sentry context metadata during the request in a Plug application. It includes defaults for scrubbing sensitive data, and options for customizing it by default. It is intended for usage with Sentry.PlugCapture as metadata added here will appear in events captured. Sending Post Body Params In order to send post body parameters you should first scrub them of sensitive information. By default, they will be scrubbed with Sentry.Plug.default_body_scrubber/1 . It can be overridden by passing the body_scrubber option, which accepts a Plug.Conn and returns a map to send. Setting :body_scrubber to nil will not send any data back. If you would like to make use of Sentry's default scrubber behavior in a custom scrubber, it can be called directly. An example configuration may look like the following: def scrub_params ( conn ) do # Makes use of the default body_scrubber to avoid sending password # and credit card information in plain text. To also prevent sending # our sensitive &quot;my_secret_field&quot; and &quot;other_sensitive_data&quot; fields, # we simply drop those keys. Sentry.PlugContext . default_body_scrubber ( conn ) |&gt; Map . drop ( [ &quot;my_secret_field&quot; , &quot;other_sensitive_data&quot; ] ) end Then pass it into Sentry.Plug: plug Sentry.PlugContext , body_scrubber : &amp; MyModule . scrub_params / 1 You can also pass it in as a {module, fun} like so: plug Sentry.PlugContext , body_scrubber : { MyModule , :scrub_params } Please Note : If you are sending large files you will want to scrub them out. Headers Scrubber By default Sentry will scrub Authorization and Authentication headers from all requests before sending them. It can be configured similarly to the body params scrubber, but is configured with the :header_scrubber key. def scrub_headers ( conn ) do # default is: Sentry.Plug.default_header_scrubber(conn) # # We do not want to include Content-Type or User-Agent in reported # headers, so we drop them. Enum . into ( conn . req_headers , %{ } ) |&gt; Map . drop ( [ &quot;content-type&quot; , &quot;user-agent&quot; ] ) end Then pass it into Sentry.Plug: plug Sentry.PlugContext , header_scrubber : &amp; MyModule . scrub_headers / 1 It can also be passed in as a {module, fun} like so: plug Sentry.PlugContext , header_scrubber : { MyModule , :scrub_headers } Cookie Scrubber By default Sentry will scrub all cookies before sending events. It can be configured similarly to the headers scrubber, but is configured with the :cookie_scrubber key. To configure scrubbing, we can set all configuration keys: plug Sentry.PlugContext, header_scrubber: &amp;MyModule.scrub_headers/1, body_scrubber: &amp;MyModule.scrub_params/1, cookie_scrubber: &amp;MyModule.scrub_cookies/1 Including Request Identifiers If you're using Phoenix, Plug.RequestId, or another method to set a request ID response header, and would like to include that information with errors reported by Sentry.PlugContext, the :request_id_header option allows you to set which header key Sentry should check. It will default to &quot;x-request-id&quot;, which Plug.RequestId (and therefore Phoenix) also default to. plug Sentry.PlugContext , request_id_header : &quot;application-request-id&quot; Remote Address Reader Sentry.PlugContext includes a request's originating IP address under the REMOTE_ADDR Environment key in Sentry. By default it is read from the x-forwarded-for HTTP header, and if this header is not present, it is read from conn.remote_ip . If you wish to read this value differently (e.g. from a different HTTP header), or modify it in some other way (e.g. by masking it), you can configure this behavior by passing the :remote_address_reader option: plug Sentry.PlugContext , remote_address_reader : &amp; MyModule . read_ip / 1","ref":"Sentry.PlugContext.html","title":"Sentry.PlugContext","type":"module"},{"doc":"","ref":"Sentry.PlugContext.html#build_request_interface_data/2","title":"Sentry.PlugContext.build_request_interface_data/2","type":"function"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Sentry.PlugContext.html#call/2","title":"Sentry.PlugContext.call/2","type":"function"},{"doc":"","ref":"Sentry.PlugContext.html#default_body_scrubber/1","title":"Sentry.PlugContext.default_body_scrubber/1","type":"function"},{"doc":"","ref":"Sentry.PlugContext.html#default_cookie_scrubber/1","title":"Sentry.PlugContext.default_cookie_scrubber/1","type":"function"},{"doc":"","ref":"Sentry.PlugContext.html#default_header_scrubber/1","title":"Sentry.PlugContext.default_header_scrubber/1","type":"function"},{"doc":"","ref":"Sentry.PlugContext.html#default_remote_address_reader/1","title":"Sentry.PlugContext.default_remote_address_reader/1","type":"function"},{"doc":"","ref":"Sentry.PlugContext.html#get_header/2","title":"Sentry.PlugContext.get_header/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Sentry.PlugContext.html#init/1","title":"Sentry.PlugContext.init/1","type":"function"},{"doc":"Recursively scrubs a map that may have nested maps or lists Accepts a list of keys to scrub, and a list of options to configure Options :scrubbed_values_regular_expressions - A list of regular expressions. Any binary values within the map that match any of the regular expressions will be scrubbed. Defaults to [~r/^(?:\d[ -]*?){13,16}$/] . :scrubbed_value - The value to replace scrubbed values with. Defaults to &quot;*********&quot; .","ref":"Sentry.PlugContext.html#scrub_map/3","title":"Sentry.PlugContext.scrub_map/3","type":"function"},{"doc":"This module is responsible for providing functionality that stores the text of source files during compilation for displaying the source code that caused an exception. Configuration There is configuration required to set up this functionality. The options include :enable_source_code_context , :root_source_code_paths , :context_lines , :source_code_exclude_patterns , and :source_code_path_pattern . The options must be set at compile-time. :enable_source_code_context - when true , enables reporting source code alongside exceptions. :root_source_code_paths - List of paths from which to start recursively reading files from. Should usually be set to [File.cwd!()] . For umbrella applications you should list all your applications paths in this list (e.g. [&quot;/tmp/craft-hex-3BIUoh/apps/app_1&quot;, &quot;/tmp/craft-hex-3BIUoh/apps/app_2&quot;] . :context_lines - The number of lines of source code before and after the line that caused the exception to be included. Defaults to 3 . :source_code_exclude_patterns - a list of Regex expressions used to exclude file paths that should not be stored or referenced when reporting exceptions. Defaults to [~r&quot;/_build/&quot;, ~r&quot;/deps/&quot;, ~r&quot;/priv/&quot;] . :source_code_path_pattern - a glob that is expanded to select files from the :root_source_code_paths . Defaults to &quot;**/*.ex&quot; . An example configuration: config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , enable_source_code_context : true , root_source_code_paths : [ File . cwd! ( ) ] , context_lines : 5 Source code storage The file contents are saved when Sentry is compiled, which can cause some complications. If a file is changed, and Sentry is not recompiled, it will still report old source code. The best way to ensure source code is up to date is to recompile Sentry itself via mix deps.compile sentry --force . It's possible to create a Mix Task alias in mix.exs to do this. The example below would allow one to run mix sentry_recompile &amp;&amp; mix compile which will force recompilation of Sentry so it has the newest source and then compile the project. The second mix compile is required due to Mix only invoking the same task once in an alias. defp aliases do [ sentry_recompile : [ &quot;compile&quot; , &quot;deps.compile sentry --force&quot; ] ] end This is an important to note especially when building for production. If your build or deployment system caches prior builds, it may not recompile Sentry and could cause issues with reported source code being out of date. Due to Sentry reading the file system and defaulting to a recursive search of directories, it is important to check your configuration and compilation environment to avoid a folder recursion issue. Problems may be seen when deploying to the root folder, so it is best to follow the practice of compiling your application in its own folder. Modifying the source_code_path_pattern configuration option from its default is also an avenue to avoid compile problems.","ref":"Sentry.Sources.html","title":"Sentry.Sources","type":"module"},{"doc":"Given the source code map, a filename and a line number, this method retrieves the source code context. When reporting source code context to the Sentry API, it expects three separate values. They are the source code for the specific line the error occurred on, the list of the source code for the lines preceding, and the list of the source code for the lines following. The number of lines in the lists depends on what is configured in :context_lines . The number configured is how many lines to get on each side of the line that caused the error. If it is configured to be 3 , the method will attempt to get the 3 lines preceding, the 3 lines following, and the line that the error occurred on, for a possible maximum of 7 lines. The three values are returned in a three element tuple as {preceding_source_code_list, source_code_from_error_line, following_source_code_list} .","ref":"Sentry.Sources.html#get_source_context/3","title":"Sentry.Sources.get_source_context/3","type":"function"},{"doc":"","ref":"Sentry.Sources.html#load_files/0","title":"Sentry.Sources.load_files/0","type":"function"},{"doc":"","ref":"Sentry.Sources.html#t:file_map/0","title":"Sentry.Sources.file_map/0","type":"type"},{"doc":"","ref":"Sentry.Sources.html#t:source_map/0","title":"Sentry.Sources.source_map/0","type":"type"},{"doc":"Provides basic utility functions.","ref":"Sentry.Util.html","title":"Sentry.Util","type":"module"},{"doc":"Generates a iso8601_timestamp without microseconds and timezone","ref":"Sentry.Util.html#iso8601_timestamp/0","title":"Sentry.Util.iso8601_timestamp/0","type":"function"},{"doc":"","ref":"Sentry.Util.html#mix_deps/0","title":"Sentry.Util.mix_deps/0","type":"function"},{"doc":"","ref":"Sentry.Util.html#mix_deps_versions/1","title":"Sentry.Util.mix_deps_versions/1","type":"function"},{"doc":"Generates a unix timestamp","ref":"Sentry.Util.html#unix_timestamp/0","title":"Sentry.Util.unix_timestamp/0","type":"function"},{"doc":"Per http://www.ietf.org/rfc/rfc4122.txt","ref":"Sentry.Util.html#uuid4_hex/0","title":"Sentry.Util.uuid4_hex/0","type":"function"},{"doc":"","ref":"Sentry.CrashError.html","title":"Sentry.CrashError","type":"exception"},{"doc":"The Official Sentry Client for Elixir which provides a simple API to capture exceptions, automatically handle Plug Exceptions and provides a backend for the Elixir Logger. This documentation represents unreleased features, for documentation on the current release, see here .","ref":"readme.html","title":"sentry","type":"extras"},{"doc":"Sentry 8.x requires Elixir 1.10 and Sentry 7.x will be maintained for applications running prior versions. Documentation for Sentry 7.x can be found here . If you would like to upgrade a project to use Sentry 8.x, see here .","ref":"readme.html#note-on-upgrading-from-sentry-7-x-to-8-x","title":"sentry - Note on upgrading from Sentry 7.x to 8.x","type":"extras"},{"doc":"To use Sentry with your projects, edit your mix.exs file and add it as a dependency. Sentry does not install a JSON library nor HTTP client by itself. Sentry will default to trying to use Jason for JSON operations and Hackney for HTTP requests, but can be configured to use other ones. To use the default ones, do: defp deps do [ # ... { :sentry , &quot;8.0.0&quot; } , { :jason , &quot;~&gt; 1.1&quot; } , { :hackney , &quot;~&gt; 1.8&quot; } , # if you are using plug_cowboy { :plug_cowboy , &quot;~&gt; 2.3&quot; } , ] end Setup with Plug and Phoenix Capturing errors in Plug applications is done with Sentry.PlugContext and Sentry.PlugCapture . Sentry.PlugContext adds contextual metadata from the current request which is then included in errors that are captured and reported by Sentry.PlugCapture . If you are using Phoenix, first add Sentry.PlugCapture above the use Phoenix.Endpoint line in your endpoint file. Sentry.PlugContext should be added below Plug.Parsers . defmodule MyAppWeb.Endpoint + use Sentry.PlugCapture use Phoenix.Endpoint, otp_app: :my_app # ... plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json], pass: [&quot;*/*&quot;], json_decoder: Phoenix.json_library() + plug Sentry.PlugContext If you are in a non-Phoenix Plug application, add Sentry.PlugCapture at the top of your Plug application, and add Sentry.PlugContext below Plug.Parsers (if it is in your stack). defmodule MyApp.Router do use Plug.Router + use Sentry.PlugCapture # ... plug Plug.Parsers, parsers: [:urlencoded, :multipart] + plug Sentry.PlugContext Capturing User Feedback If you would like to capture user feedback as described here , the Sentry.get_last_event_id_and_source() function can be used to see if Sentry has sent an event within the current Plug process, and the source of that event. :plug will be the source for events coming from Sentry.PlugCapture . The options described in the Sentry documentation linked above can be encoded into the response as well. An example Phoenix application setup that wanted to display the user feedback form on 500 responses on requests accepting HTML could look like: defmodule MyAppWeb.ErrorView do # ... def render ( &quot;500.html&quot; , _assigns ) do case Sentry . get_last_event_id_and_source ( ) do { event_id , :plug } when is_binary ( event_id ) -&gt; opts = # can do %{eventId: event_id, title: &quot;My custom title&quot;} %{ eventId : event_id } |&gt; Jason . encode! ( ) ~E&quot;&quot;&quot; &lt;script src=&quot;https://browser.sentry-cdn.com/5.9.1/bundle.min.js&quot; integrity=&quot;sha384-/x1aHz0nKRd6zVUazsV6CbQvjJvr6zQL2CHbQZf3yoLkezyEtZUpqUNnOLW9Nt3v&quot; crossorigin=&quot;anonymous&quot;&gt;&lt;/script&gt; &lt;script&gt; Sentry.init({ dsn: &#39;&lt;%= Sentry.Config.dsn() %&gt;&#39; }); Sentry.showReportDialog(&lt;%= raw opts %&gt;) &lt;/script&gt; &quot;&quot;&quot; _ -&gt; &quot;Error&quot; end # ... end Capture Crashed Process Exceptions This library comes with an extension to capture all error messages that the Plug handler might not. This is based on Logger.Backend . You can add it as a backend when your application starts: # lib/my_app/application.ex + def start(_type, _args) do + Logger.add_backend(Sentry.LoggerBackend) The backend can also be configured to capture Logger metadata, which is detailed here . Capture Arbitrary Exceptions Sometimes you want to capture specific exceptions. To do so, use Sentry.capture_exception/2 . try do ThisWillError . really ( ) rescue my_exception -&gt; Sentry . capture_exception ( my_exception , [ stacktrace : __STACKTRACE__ , extra : %{ extra : information } ] ) end Capture Non-Exception Events Sometimes you want to capture messages that are not Exceptions. Sentry . capture_message ( &quot;custom_event_name&quot; , extra : %{ extra : information } ) For optional settings check the docs .","ref":"readme.html#installation","title":"sentry - Installation","type":"extras"},{"doc":"Sentry has a range of configuration options, but most applications will have a configuration that looks like the following: # config/config.exs config :sentry , dsn : &quot;https://public_key@app.getsentry.com/1&quot; , environment_name : Mix . env ( ) , included_environments : [ :prod ] , enable_source_code_context : true , root_source_code_paths : [ File . cwd! ( ) ] The environment_name and included_environments work together to determine if and when Sentry should send events to the server. If the currently configured :environment_name is in the configured list of :included_environments , the event will be sent. The full range of options is the following: Key Required Default Notes dsn True n/a environment_name False :prod included_environments False [:test, :dev, :prod] If you need non-standard mix env names you need to include it here tags False %{} release False None server_name False None client False Sentry.HackneyClient If you need different functionality for the HTTP client, you can define your own module that implements the Sentry.HTTPClient behaviour and set client to that module hackney_opts False [pool: :sentry_pool] hackney_pool_max_connections False 50 hackney_pool_timeout False 5000 before_send_event False after_send_event False sample_rate False 1.0 send_result False :none You may want to set it to :sync if testing your Sentry integration. See &quot;Testing with Sentry&quot; send_max_attempts False 4 in_app_module_allow_list False [] report_deps False True Will attempt to load Mix dependencies at compile time to report alongside events enable_source_code_context False False root_source_code_paths Required if enable_source_code_context is enabled Should usually be set to [File.cwd!()] . For umbrella applications you should list all your applications paths in this list (e.g. [&quot;\#{File.cwd!()}/apps/app_1&quot;, &quot;\#{File.cwd!()}/apps/app_2&quot;] . context_lines False 3 source_code_exclude_patterns False [~r&quot;/_build/&quot;, ~r&quot;/deps/&quot;, ~r&quot;/priv/&quot;] source_code_path_pattern False &quot;**/*.ex&quot; filter False Module where the filter rules are defined (see Filtering Exceptions ) json_library False Jason log_level False :warning This sets the log level used when Sentry fails to send an event due to an invalid event or API error max_breadcrumbs False 100 This sets the maximum number of breadcrumbs to send to Sentry when creating an event Sentry uses the hackney HTTP client for HTTP requests. Sentry starts its own hackney pool named :sentry_pool with a default connection pool of 50, and a connection timeout of 5000 milliseconds. The pool can be configured with the hackney_pool_max_connections and hackney_pool_timeout configuration keys. If you need to set other hackney configurations for things like a proxy, using your own pool or response timeouts, the hackney_opts configuration is passed directly to hackney for each request. Context and Breadcrumbs Sentry has multiple options for including contextual information. They are organized into &quot;Tags&quot;, &quot;User&quot;, and &quot;Extra&quot;, and Sentry's documentation on them is here . Breadcrumbs are a similar concept and Sentry's documentation covers them here . In Elixir this can be complicated due to processes being isolated from one another. Tags context can be set globally through configuration, and all contexts can be set within a process, and on individual events. If an event is sent within a process that has some context configured it will include that context in the event. Examples of each are below, and for more information see the documentation of Sentry.Context . # Global Tags context via configuration: config :sentry , tags : %{ my_app_version : &quot;14.30.10&quot; } # ... # Process-based Context Sentry.Context . set_extra_context ( %{ day_of_week : &quot;Friday&quot; } ) Sentry.Context . set_user_context ( %{ id : 24 , username : &quot;user_username&quot; , has_subscription : true } ) Sentry.Context . set_tags_context ( %{ locale : &quot;en-us&quot; } ) Sentry.Context . add_breadcrumb ( %{ category : &quot;web.request&quot; } ) # Event-based Context Sentry . capture_exception ( exception , [ tags : %{ locale : &quot;en-us&quot; , } , user : %{ id : 34 } , extra : %{ day_of_week : &quot;Friday&quot; } , breadcrumbs : [ %{ timestamp : 1461185753845 , category : &quot;web.request&quot; } ] ] Fingerprinting By default, Sentry aggregates reported events according to the attributes of the event, but users may need to override this functionality via fingerprinting . To achieve that in Sentry Elixir, one can use the before_send_event configuration callback. If there are certain types of errors you would like to have grouped differently, they can be matched on in the callback, and have the fingerprint attribute changed before the event is sent. An example configuration and implementation could look like: # lib/sentry.ex defmodule MyApp.Sentry def before_send ( %{ exception : [ %{ type : DBConnection.ConnectionError } ] } = event ) do %{ event | fingerprint : [ &quot;ecto&quot; , &quot;db_connection&quot; , &quot;timeout&quot; ] } end def before_send ( event ) do event end end # config.exs config :sentry , before_send_event : { MyApp.Sentry , :before_send } , # ... Reporting Exceptions with Source Code Sentry's server supports showing the source code that caused an error, but depending on deployment, the source code for an application is not guaranteed to be available while it is running. To work around this, the Sentry library reads and stores the source code at compile time. This has some unfortunate implications. If a file is changed, and Sentry is not recompiled, it will still report old source code. The best way to ensure source code is up to date is to recompile Sentry itself via mix deps.compile sentry --force . It's possible to create a Mix Task alias in mix.exs to do this. The example below allows one to run mix sentry_recompile &amp;&amp; mix compile which will compile any uncompiled or changed parts of the application, and then force recompilation of Sentry so it has the newest source. The second mix compile is required due to Mix only invoking the same task once in an alias. # mix.exs defp aliases do [ sentry_recompile : [ &quot;compile&quot; , &quot;deps.compile sentry --force&quot; ] ] end For more documentation, see Sentry.Sources .","ref":"readme.html#configuration","title":"sentry - Configuration","type":"extras"},{"doc":"To ensure you've set up your configuration correctly we recommend running the included mix task. It can be tested on different Mix environments and will tell you if it is not currently configured to send events in that environment: $ MIX_ENV=dev mix sentry.send_test_event Client configuration: server: https://sentry.io/ public_key: public secret_key: secret included_environments: [:prod] current environment_name: :dev :dev is not in [:prod] so no test event will be sent $ MIX_ENV=prod mix sentry.send_test_event Client configuration: server: https://sentry.io/ public_key: public secret_key: secret included_environments: [:prod] current environment_name: :prod Sending test event!","ref":"readme.html#testing-your-configuration","title":"sentry - Testing Your Configuration","type":"extras"},{"doc":"In some cases, users may want to test that certain actions in their application cause a report to be sent to Sentry. Sentry itself does this by using Bypass . It is important to note that when modifying the environment configuration the test case should not be run asynchronously. Not returning the environment configuration to its original state could also affect other tests depending on how the Sentry configuration interacts with them. Example: test &quot;add/2 does not raise but sends an event to Sentry when given bad input&quot; do bypass = Bypass . open ( ) Bypass . expect ( bypass , fn conn -&gt; { :ok , _body , conn } = Plug.Conn . read_body ( conn ) Plug.Conn . resp ( conn , 200 , ~s&lt;{&quot;id&quot;: &quot;340&quot;}&gt; ) end ) Application . put_env ( :sentry , :dsn , &quot;http://public:secret@localhost: \#{ bypass . port } /1&quot; ) Application . put_env ( :sentry , :send_result , :sync ) MyModule . add ( 1 , &quot;a&quot; ) end When testing, you will also want to set the send_result type to :sync , so the request is done synchronously.","ref":"readme.html#testing-with-sentry","title":"sentry - Testing with Sentry","type":"extras"},{"doc":"This project is Licensed under the MIT License .","ref":"readme.html#license","title":"sentry - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Various fixes &amp; improvements Bump min craft version to 1.4.2 (795bfd12) by @sl0thentr0py Add github target to craft (ef563cc5) by @sl0thentr0py Bump min craft version (56516be2) by @sl0thentr0py Improve deprecation of Sentry.Config.root_source_code_path/0 (#558) by @whatyouhide Wrap HTTP requests in try/catch (#515) by @ruslandoga Remove extra config files (#556) by @yordis Remove use of deprecated Mix.Config (#555) by @whatyouhide Add release/** branches to ci for craft (dfaffb9f) by @sl0thentr0py Fix typo in moduledoc (#534) by @louisvisser Check :hackney application when starting (#554) by @whatyouhide feat(event): filter more exceptions by default (#550) by @gpouilloux Fix example configuration for Sentry.Sources (#543) by @scudelletti Use module attribute for dictionary key consistently (#537) by @tmecklem Fix send_event/2 typespec (#545) by @ruslandoga Update badges in the README (#548) by @ruslandoga Update ex_docs to 0.29+ (#549) by @ruslandoga Fix Elixir 1.15 warnings (#553) by @dustinfarris Add :remote_address_reader PlugContext option (#519) by @michallepicki Traverse full domain list when checking for excluded domains (#508) by @martosaur Add craft with target hex (#532) by @sl0thentr0py Add Sentry to LICENSE (#530) by @sl0thentr0py Update ci setup-beam action name (#531) by @sl0thentr0py allow logging from tasks (#517) by @ruslandoga Improve DSN parsing and Endpoint building (#507) by @AtjonTV Plus 14 more","ref":"changelog.html#8-1-0","title":"Changelog - 8.1.0","type":"extras"},{"doc":"Bug Fixes Remove function that disables non-group leader logging (#467) Handle :unsampled events in Sentry.send_test_event (#474) Fix dialyzer reporting unmatched_return for Sentry.PlugCapture (#475) Use correct Plug.Parsers exception module (#482)","ref":"changelog.html#8-0-6-2021-09-28","title":"Changelog - 8.0.6 (2021-09-28)","type":"extras"},{"doc":"Enhancements Support lists in scrubbing (#442) Send Sentry reports on uncaught throws/exits (#447) Bug Fixes Deprecate Sentry.Config.in_app_module_whitelist in favor of Sentry.Config.in_app_module_allow_list (#450) Update outdated Sentry.Plug documentation (#452) Update Sentry.HTTPClient documentation (#456)","ref":"changelog.html#8-0-5-2021-02-14","title":"Changelog - 8.0.5 (2021-02-14)","type":"extras"},{"doc":"Bug Fixes Do not read DSN config at compile time (#441)","ref":"changelog.html#8-0-4-2020-11-16","title":"Changelog - 8.0.4 (2020-11-16)","type":"extras"},{"doc":"Enhancements Update package &amp; docs configuration (#432) Add Plug.Status filter example (#433) Support multiple source code root paths in Sentry.Sources (#437) Bug Fixes Fix dialyzer reporting unmatched_return for Sentry.PlugCapture (#436) Align Sentry event levels with Elixir logging levels (#439)","ref":"changelog.html#8-0-3-2020-11-11","title":"Changelog - 8.0.3 (2020-11-11)","type":"extras"},{"doc":"Enhancements Log error when JSON is unencodable (#429) Set logger event level to logger message level (#430) Limit breadcrumbs on add_breadcrumb (#431)","ref":"changelog.html#8-0-2-2020-09-06","title":"Changelog - 8.0.2 (2020-09-06)","type":"extras"},{"doc":"Enhancements Add plug parsing errors to list of default excluded params (#414) Make Sentry.PlugContext.scrub_map public (#417) Allow users to configure maximum number of breadcrumbs (#418)","ref":"changelog.html#8-0-1-2020-08-08","title":"Changelog - 8.0.1 (2020-08-08)","type":"extras"},{"doc":"7.x -&gt; 8.0 Upgrade Guide Bug Fixes Fix documentation for Sentry.PlugContext (#410)","ref":"changelog.html#8-0-0-2020-07-13","title":"Changelog - 8.0.0 (2020-07-13)","type":"extras"},{"doc":"Bug Fixes Fix trying to transform erlang error coming from PlugCapture (#406)","ref":"changelog.html#8-0-0-rc-2-2020-07-01","title":"Changelog - 8.0.0-rc.2 (2020-07-01)","type":"extras"},{"doc":"Bug Fixes Remove changes that were unintentionally included in build","ref":"changelog.html#8-0-0-rc-1-2020-06-29","title":"Changelog - 8.0.0-rc.1 (2020-06-29)","type":"extras"},{"doc":"Enhancements Cache environment config in application config (#393) Allow configuring LoggerBackend to send all messages, not just exceptions (e.g. Logger.error(&quot;I am an error message&quot;) ) Bug Fixes fix request url port in payloads for HTTPS requests (#391) Breaking Changes Change default included_environments to only include :prod by default (#370) Change default event send type to :none instead of :async (#341) Make hackney an optional dependency, and simplify Sentry.HTTPClient behaviour (#400) Use Logger.metadata for Sentry.Context, no longer return metadata values on set_* functions, and rename set_http_context to set_request_context (#401) Move excluded exceptions from Sentry.Plug to Sentry.DefaultEventFilter (#402) Remove Sentry.Plug and Sentry.Phoenix.Endpoint in favor of Sentry.PlugContext and Sentry.PlugCapture (#402) Remove feedback form rendering and configuration (#402) Logger metadata is now specified by key in LoggerBackend instead of enabled/disabled (#403) Require Elixir 1.10 and optionally plug_cowboy 2.3 (#403) Sentry.capture_exception/1 now only accepts exceptions (#403)","ref":"changelog.html#8-0-0-rc-0-2020-06-24","title":"Changelog - 8.0.0-rc.0 (2020-06-24)","type":"extras"},{"doc":"Enhancements Allow configuring gather feedback form for Sentry.Plug errors (#387)","ref":"changelog.html#7-2-4-2020-03-09","title":"Changelog - 7.2.4 (2020-03-09)","type":"extras"},{"doc":"Enhancements Allow gathering feedback from Sentry.Plug errors (#385)","ref":"changelog.html#7-2-3-2020-02-27","title":"Changelog - 7.2.3 (2020-02-27)","type":"extras"},{"doc":"Bug Fixes Ensure stacktrace is list in LoggerBackend (#380)","ref":"changelog.html#7-2-2-2020-02-13","title":"Changelog - 7.2.2 (2020-02-13)","type":"extras"},{"doc":"Bug Fixes Improve documentation for Sentry.Client.send_event/2 (#367) Fix potential Logger deadlock (#372) Pass the same exception for NoRouteError in Sentry.Phoenix.Endpoint (#376) Handle new MFA for duplicate Plug errors (#377) Update docs to recommend using application environment config for adding Sentry.LoggerBackend (#379)","ref":"changelog.html#7-2-1-2019-12-05","title":"Changelog - 7.2.1 (2019-12-05)","type":"extras"},{"doc":"Enhancements Allow filtering of Events using before_send_event (#364) Bug Fixes Remove newline from Logger for API error (#351) Add docs for Sentry.Context (#352) Avoid error duplication for Plug errors (#355) Fix issue in Sentry.Sources docs around recompilation (#357)","ref":"changelog.html#7-2-0-2019-10-23","title":"Changelog - 7.2.0 (2019-10-23)","type":"extras"},{"doc":"Enhancements Option to include Logger.metadata in Sentry.LoggerBackend (#338) Send maximum length of args in stacktrace (#340) Fix dialyzer warning when using Sentry.Phoenix.Endpoint (#344) Bug Fixes Fix documentation error relating to File.cwd!() (#346) Add parens to File.cwd!() in documentation (#347) Check that DSN is binary (#348)","ref":"changelog.html#7-1-0-2019-06-11","title":"Changelog - 7.1.0 (2019-06-11)","type":"extras"},{"doc":"Enhancements Allow configuring Sentry log level (#334)","ref":"changelog.html#7-0-6-2019-04-17","title":"Changelog - 7.0.6 (2019-04-17)","type":"extras"},{"doc":"Bug Fixes Strip leading &quot;Elixir.&quot; from module name on error type (#330)","ref":"changelog.html#7-0-5-2019-04-05","title":"Changelog - 7.0.5 (2019-04-05)","type":"extras"},{"doc":"Bug Fixes Do not error if you cannot format the remote IP or port (#326)","ref":"changelog.html#7-0-4-2019-02-12","title":"Changelog - 7.0.4 (2019-02-12)","type":"extras"},{"doc":"Bug Fixes Fix issue from using spawn_link stacktrace (#315) Relax plug_cowboy versions (#314)","ref":"changelog.html#7-0-3-2018-11-14","title":"Changelog - 7.0.3 (2018-11-14)","type":"extras"},{"doc":"Bug Fixes Fix sending Phoenix.Router.NoRouteError when using Sentry.Phoenix.Endpoint (#309)","ref":"changelog.html#7-0-2-2018-11-01","title":"Changelog - 7.0.2 (2018-11-01)","type":"extras"},{"doc":"Enhancements Remove Poison from applications list (#306)","ref":"changelog.html#7-0-1-2018-10-01","title":"Changelog - 7.0.1 (2018-10-01)","type":"extras"},{"doc":"Enhancements Implement Sentry.LoggerBackend Breaking Changes Replace Poison with configurable JSON library Require Elixir 1.7+ Remove Sentry.Logger","ref":"changelog.html#7-0-0-2018-09-07","title":"Changelog - 7.0.0 (2018-09-07)","type":"extras"},{"doc":"Enhancements Add deps reporting back (#305 / #301)","ref":"changelog.html#6-4-2-2018-09-05","title":"Changelog - 6.4.2 (2018-09-05)","type":"extras"},{"doc":"Bug Fixes Remove UUID dependency (#298) Fix link in documentation (#300)","ref":"changelog.html#6-4-1-2018-07-26","title":"Changelog - 6.4.1 (2018-07-26)","type":"extras"},{"doc":"Enhancements Add documentation detail around including source code (#287) Document fingerprinting (#288) Document Sentry.Context (#289) Add CONTRIBUTING.md (#290) Document cookie scrubber (#291) Document testing with Sentry (#292) Bug Fixes Change report_deps default value to false to avoid compiler bug (#285) Limit size of messages (#293) Use elixir_uuid instead of uuid (#295)","ref":"changelog.html#6-4-0-2018-07-02","title":"Changelog - 6.4.0 (2018-07-02)","type":"extras"},{"doc":"Enhancements Use the stacktrace passed to Sentry.Event.transform_exception/2 when calling Exception.normalize/3 (#266) Reduce Logger noise in HTTP Client (#274) Use Plug.Conn.get_peer_data/1 (#273) Bug Fixes Add documentation for capturing arbitrary events (#272) Fix typo in README.md (#277)","ref":"changelog.html#6-3-0-2018-06-26","title":"Changelog - 6.3.0 (2018-06-26)","type":"extras"},{"doc":"Enhancements Accept public key DSNs (#263)","ref":"changelog.html#6-2-1-2018-04-24","title":"Changelog - 6.2.1 (2018-04-24)","type":"extras"},{"doc":"Enhancements Allow overriding in Sentry.Plug (#261) Implement Sentry.Phoenix.Endpoint to capture errors in Phoenix.Endpoint (#259) Bug Fixes Fix sending events from remote_console (#262) Add filter option to configuration table in README (#255) Default to not sending cookies, but allow configuration to send (#254) Do not raise on invalid DSN (#218)","ref":"changelog.html#6-2-0-2018-04-04","title":"Changelog - 6.2.0 (2018-04-04)","type":"extras"},{"doc":"Enhancements Elixir 1.6.0 formatted (#246) Improve documentation around source code compilation (#242) Update typespecs (#249) Report errors from :kernel.spawn processes (#251) Bug Fixes Fix doc typos (#245) Remove Sentry.Event compile warning (#248) Fix enable_source_code_context configuration (#247)","ref":"changelog.html#6-1-0-2017-12-07","title":"Changelog - 6.1.0 (2017-12-07)","type":"extras"},{"doc":"Enhancements Improve README documentation (#236) Fix GenEvent warning (#237, #239) Bug Fixes Fix error_type reported in Sentry.Plug (#238)","ref":"changelog.html#6-0-5-2017-12-07","title":"Changelog - 6.0.5 (2017-12-07)","type":"extras"},{"doc":"Enhancements Allow string for included_environments by splitting on commas (#234) Bug Fixes Handle :error when sending test event (#228)","ref":"changelog.html#6-0-4-2017-11-20","title":"Changelog - 6.0.4 (2017-11-20)","type":"extras"},{"doc":"Enhancements Fix tests for differing versions of Erlang/Elixir (#221) Bug Fixes Fix invalid value for stacktrace via Event rendering layer (#224)","ref":"changelog.html#6-0-3-2017-11-01","title":"Changelog - 6.0.3 (2017-11-01)","type":"extras"},{"doc":"Enhancements Improve Sentry.Logger documentation (#217) Bug Fixes Handle Plug.Upload during scrubbing (#208) Do not check DSN for source_code_path_pattern configuration (#211) Fix culprit ambiguity (#214)","ref":"changelog.html#6-0-2-2017-10-03","title":"Changelog - 6.0.2 (2017-10-03)","type":"extras"},{"doc":"Bug Fixes Fix filters and test mix task (#206) Enhancements Improve README clarity (#202)","ref":"changelog.html#6-0-1-2017-09-06","title":"Changelog - 6.0.1 (2017-09-06)","type":"extras"},{"doc":"See these 5.0.0 to 6.0.0 upgrade instructions to update your existing app. Breaking Changes Remove use_error_logger configuration (#196) enable_source_code_context is no longer required configuration (#201) Bug Fixes Fix README error (#197) Prevent overwriting server_name option (#200) Enhancements Scrubbing of nested maps (#192) Allow Hackney 1.9 and later (#199)","ref":"changelog.html#6-0-0-2017-08-29","title":"Changelog - 6.0.0 (2017-08-29)","type":"extras"},{"doc":"Bug Fixes Fix logger and context usage (#185)","ref":"changelog.html#5-0-1-2017-07-18","title":"Changelog - 5.0.1 (2017-07-18)","type":"extras"},{"doc":"Backward incompatible changes Allow specifying sync/async/none when getting result of sending event (#174) Enhancements Modules (#182) Config from system and DSN (#180) App Frames (#177) Sampling (#176) Post event hook (#175) Improve documentation around recompilation for source code context (#171) Use better arity logic in stacktraces (#170) Allow custom fingerprinting (#160) Bug Fixes Fix README typo (#159) Fix the backoff to really be exponential (#162)","ref":"changelog.html#5-0-0-2017-07-10","title":"Changelog - 5.0.0 (2017-07-10)","type":"extras"},{"doc":"Enhancements Update and improve Travis build matrix (#155) Specify behaviour for Sentry HTTP clients (#158)","ref":"changelog.html#4-0-3-2017-05-17","title":"Changelog - 4.0.3 (2017-05-17)","type":"extras"},{"doc":"Enhancements Relax hackney requirements","ref":"changelog.html#4-0-2-2017-04-26","title":"Changelog - 4.0.2 (2017-04-26)","type":"extras"},{"doc":"Enhancements Bump hackney to a version that fixes major bug (#153)","ref":"changelog.html#4-0-1-2017-04-25","title":"Changelog - 4.0.1 (2017-04-25)","type":"extras"},{"doc":"See these 3.0.0 to 4.0.0 upgrade instructions to update your existing app. Enhancements Bump hackney to a version that isn't retired (#135) Improve Logger reporting (#136) Accept keyword lists in Sentry.Context.add_breadcrumb/1 (#139) Add elements to beginning of breadcrumbs list for performance (#141) Close unread hackney responses properly (#149) Improve Sentry.Client code style (#147) Fix invalid specs in Sentry methods (#146) Allow setting client at runtime (#150) Backward incompatible changes Return :ignored instead of {:ok, &quot;&quot;} when event is not sent because environment_name is not in included_environments in Sentry.send_event , Sentry.capture_exception , or Sentry.capture_message (#146) Return :ignored and log warning instead of returning {:ok, &quot;Sentry: unable to parse exception&quot;} when unable to parse exception in Sentry.send_event , Sentry.capture_exception , or Sentry.capture_message (#146) Return {:ok, Task} instead of Task when an event is successfully sent with Sentry.send_event , Sentry.capture_exception , or Sentry.capture_message (#146) Ignore non-existent route exceptions (#110) Sending source code as context when reporting errors (#138)","ref":"changelog.html#4-0-0-2017-04-20","title":"Changelog - 4.0.0 (2017-04-20)","type":"extras"},{"doc":"Enhancements Add dialyzer support (#128) Backward incompatible changes Fix default configuration (#124) Start and use separate Sentry hackney pool instead of default (#130) Return :error instead of raising when encoding invalid JSON (#131)","ref":"changelog.html#3-0-0-2017-03-02","title":"Changelog - 3.0.0 (2017-03-02)","type":"extras"},{"doc":"Enhancements Allow setting hackney_opts Add Sentry.capture_message/1 Allow reading :dsn from System at runtime by configuring as {:system, &quot;ENV_VAR&quot;}","ref":"changelog.html#2-2-0-2017-02-15","title":"Changelog - 2.2.0 (2017-02-15)","type":"extras"},{"doc":"Enhancements Allow filtering which exceptions are sent via Sentry.EventFilter behaviour Add Sentry.Context.set_http_context/1 Bug Fixes Fix usage of deprecated modules Fix README documentation Fix timestamp parameter format","ref":"changelog.html#2-1-0-2016-12-17","title":"Changelog - 2.1.0 (2016-12-17)","type":"extras"},{"doc":"Bug Fixes Fix regex checking of non-binary values","ref":"changelog.html#2-0-2-2016-12-08","title":"Changelog - 2.0.2 (2016-12-08)","type":"extras"},{"doc":"Bug Fixes Fix compilation error when Plug is not available","ref":"changelog.html#2-0-1-2016-12-05","title":"Changelog - 2.0.1 (2016-12-05)","type":"extras"},{"doc":"Enhancements Return a task when sending a Sentry event Provide default scrubber for request body and headers ( Sentry.Plug.default_body_scrubber and Sentry.Plug.default_header_scrubber ) Header scrubbing can now be configured with :header_scrubber Bug Fixes Ensure mix sentry.send_test_event finishes sending event before ending Mix task Backward incompatible changes Sentry.capture_exception/1 now returns a Task instead of {:ok, PID} Sentry.Plug :scrubber option has been removed in favor of the more descriptive :body_scrubber option, which defaults to newly added Sentry.Plug.default_scrubber/1 New option for Sentry.Plug :header_scrubber defaults to newly added Sentry.Plug.default_header_scrubber/1 Request bodies were not previously sent by default. Because of above change, request bodies are now sent by default after being scrubbed by default scrubber. To prevent sending any data, :body_scrubber should be set to nil","ref":"changelog.html#2-0-0-2016-11-28","title":"Changelog - 2.0.0 (2016-11-28)","type":"extras"}]